using System;
using System.Linq;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using SmartX;

namespace ITC81DB
{
    public class ModbusFunctionCode
    {
        public static readonly byte FunctionCode_04 = 0x04;
        public static readonly byte FunctionCode_16 = 0x16;
    }

    public class ModbusExceptionCode
    {
        public static readonly byte _01_IllegalFunction = 0x01;
        public static readonly byte _02_IllegalDataAddress = 0x02;
        public static readonly byte _03_IllegalDataValue = 0x03;
        public static readonly byte _04_ServerDeviceFailure = 0x04;
    }

    public class Modbus
    {
        #region Field
        public static int StartAddress = 10; // 시작 Address
        public static int DataRegisterLength = 34; // 전체 Register
        public static int DataLength = 68; // 전체 bytes
        public int ModbusTransactionID;

        /// <summary>
        /// RTU CRC Table
        /// </summary>
        private readonly ushort[] CRCTable =
        {
            0X0000, 0XC0C1, 0XC181, 0X0140, 0XC301, 0X03C0, 0X0280, 0XC241, 0XC601, 0X06C0,
            0X0780, 0XC741, 0X0500, 0XC5C1, 0XC481, 0X0440, 0XCC01, 0X0CC0, 0X0D80, 0XCD41,
            0X0F00, 0XCFC1, 0XCE81, 0X0E40, 0X0A00, 0XCAC1, 0XCB81, 0X0B40, 0XC901, 0X09C0,
            0X0880, 0XC841, 0XD801, 0X18C0, 0X1980, 0XD941, 0X1B00, 0XDBC1, 0XDA81, 0X1A40,
            0X1E00, 0XDEC1, 0XDF81, 0X1F40, 0XDD01, 0X1DC0, 0X1C80, 0XDC41, 0X1400, 0XD4C1,
            0XD581, 0X1540, 0XD701, 0X17C0, 0X1680, 0XD641, 0XD201, 0X12C0, 0X1380, 0XD341,
            0X1100, 0XD1C1, 0XD081, 0X1040, 0XF001, 0X30C0, 0X3180, 0XF141, 0X3300, 0XF3C1,
            0XF281, 0X3240, 0X3600, 0XF6C1, 0XF781, 0X3740, 0XF501, 0X35C0, 0X3480, 0XF441,
            0X3C00, 0XFCC1, 0XFD81, 0X3D40, 0XFF01, 0X3FC0, 0X3E80, 0XFE41, 0XFA01, 0X3AC0,
            0X3B80, 0XFB41, 0X3900, 0XF9C1, 0XF881, 0X3840, 0X2800, 0XE8C1, 0XE981, 0X2940,
            0XEB01, 0X2BC0, 0X2A80, 0XEA41, 0XEE01, 0X2EC0, 0X2F80, 0XEF41, 0X2D00, 0XEDC1,
            0XEC81, 0X2C40, 0XE401, 0X24C0, 0X2580, 0XE541, 0X2700, 0XE7C1, 0XE681, 0X2640,
            0X2200, 0XE2C1, 0XE381, 0X2340, 0XE101, 0X21C0, 0X2080, 0XE041, 0XA001, 0X60C0,
            0X6180, 0XA141, 0X6300, 0XA3C1, 0XA281, 0X6240, 0X6600, 0XA6C1, 0XA781, 0X6740,
            0XA501, 0X65C0, 0X6480, 0XA441, 0X6C00, 0XACC1, 0XAD81, 0X6D40, 0XAF01, 0X6FC0,
            0X6E80, 0XAE41, 0XAA01, 0X6AC0, 0X6B80, 0XAB41, 0X6900, 0XA9C1, 0XA881, 0X6840,
            0X7800, 0XB8C1, 0XB981, 0X7940, 0XBB01, 0X7BC0, 0X7A80, 0XBA41, 0XBE01, 0X7EC0,
            0X7F80, 0XBF41, 0X7D00, 0XBDC1, 0XBC81, 0X7C40, 0XB401, 0X74C0, 0X7580, 0XB541,
            0X7700, 0XB7C1, 0XB681, 0X7640, 0X7200, 0XB2C1, 0XB381, 0X7340, 0XB101, 0X71C0,
            0X7080, 0XB041, 0X5000, 0X90C1, 0X9181, 0X5140, 0X9301, 0X53C0, 0X5280, 0X9241,
            0X9601, 0X56C0, 0X5780, 0X9741, 0X5500, 0X95C1, 0X9481, 0X5440, 0X9C01, 0X5CC0,
            0X5D80, 0X9D41, 0X5F00, 0X9FC1, 0X9E81, 0X5E40, 0X5A00, 0X9AC1, 0X9B81, 0X5B40,
            0X9901, 0X59C0, 0X5880, 0X9841, 0X8801, 0X48C0, 0X4980, 0X8941, 0X4B00, 0X8BC1,
            0X8A81, 0X4A40, 0X4E00, 0X8EC1, 0X8F81, 0X4F40, 0X8D01, 0X4DC0, 0X4C80, 0X8C41,
            0X4400, 0X84C1, 0X8581, 0X4540, 0X8701, 0X47C0, 0X4680, 0X8641, 0X8201, 0X42C0,
            0X4380, 0X8341, 0X4100, 0X81C1, 0X8081, 0X4040
        };
        #endregion

        #region Constructor
        public Modbus()
        {
            this.DefaultSetting();
        }
        #endregion

        #region Property

        #endregion

        #region Method
        private void DefaultSetting()
        {
            this.ModbusTransactionID = 0;
        }

        public static byte[] GetBytes(int argument)
        {
            byte[] byteArray = BitConverter.GetBytes(argument);
            return byteArray;
        }
        public static byte[] GetBytes(Single argument)
        {
            byte[] byteArray = BitConverter.GetBytes(argument);
            return byteArray;
        }
        public static byte[] GetBytes(uint argument)
        {
            byte[] byteArray = BitConverter.GetBytes(argument);
            return byteArray;
        }
        
        /// <summary>
        /// 요청받은 Data Error Check(RTU)
        /// </summary>
        /// <param name="readByte">전송받은 전체 byte array</param>
        /// <returns></returns>
        public byte CheckRequestRTUData(byte[] readByte)
        {
            byte ret = 0x00;
            int quantity;
            int startAddressInt;
            byte[] startAddressByte = new byte[2] { readByte[2], readByte[3] };
            byte[] numberOfRegisterByte = new byte[2] { readByte[4], readByte[5] };

            // Function Code Error : 01
            if (readByte[1] != 0x04)
                ret = 0x01;
            else
            {
                if (BitConverter.IsLittleEndian)
                    Array.Reverse(startAddressByte);
                startAddressInt = BitConverter.ToUInt16(startAddressByte, 0);

                if (BitConverter.IsLittleEndian)
                    Array.Reverse(numberOfRegisterByte);
                quantity = BitConverter.ToUInt16(numberOfRegisterByte, 0);

                // Quantity of Registers Error : 03
                if (quantity < 1 || quantity > DataRegisterLength)
                    ret = 0x03;
                else
                {
                    // Starting Address and Starting Address + Quantity of Registers Error : 02
                    if (10 > startAddressInt || startAddressInt > StartAddress + DataRegisterLength)
                        ret = 0x02;
                    else
                    {
                        if (startAddressInt + quantity > StartAddress + DataRegisterLength)
                            ret = 0x02;
                        else
                        {
                            byte[] crc = this.MakeRTUCRC(readByte, readByte.Length);
                            int crcInt;
                            crcInt = BitConverter.ToUInt16(crc, 0);

                            // CRC Error : 04
                            if (crcInt != 0)
                                ret = 0x21;
                            else
                                ret = 0x00;
                        }
                    }
                }
            }

            return ret;
        }

        /// <summary>
        /// 요청받은 Data Error Check(TCP)
        /// </summary>
        /// <param name="readByte">전송받은 전체 byte array</param>
        /// <returns></returns>
        public byte CheckRequestTCPData(byte[] readByte)
        {
            byte ret = 0x00;
            int quantity;
            int startAddressInt;
            byte[] startAddressByte = new byte[2] { readByte[8], readByte[9] };
            byte[] numberOfRegisterByte = new byte[2] { readByte[10], readByte[11] };

            // Function Code Error : 01
            if (readByte[7] != 0x04)
                ret = 0x01;
            else
            {
                if (BitConverter.IsLittleEndian)
                    Array.Reverse(startAddressByte);
                startAddressInt = BitConverter.ToUInt16(startAddressByte, 0);

                if (BitConverter.IsLittleEndian)
                    Array.Reverse(numberOfRegisterByte);
                quantity = BitConverter.ToUInt16(numberOfRegisterByte, 0);

                // Quantity of Registers Error : 03
                if (quantity < 1 || quantity > DataRegisterLength)
                    ret = 0x03;
                else
                {
                    // Starting Address and Starting Address + Quantity of Registers Error : 02
                    if (10 > startAddressInt || startAddressInt > StartAddress + DataRegisterLength)
                        ret = 0x02;
                    else
                    {
                        if (startAddressInt + quantity > StartAddress + DataRegisterLength)
                            ret = 0x02;
                        else
                            ret = 0x00;

                    }
                }
            }

            return ret;
        }



        /// <summary>
        /// RTU CRC 제작 함수 - CRCTable 이용
        /// </summary>
        /// <param name="bytes">byte array</param>
        /// <param name="length">CRC 적용할 길이(0~)</param>
        /// <returns></returns>
        public byte[] MakeRTUCRC(byte[] bytes, int length)
        {
            int icrc = 0xFFFF;
            for (int i = 0; i < length; i++)
            {
                icrc = (icrc >> 8) ^ this.CRCTable[(icrc ^ bytes[i]) & 0xff];
            }
            byte[] ret = BitConverter.GetBytes(icrc);

            return ret;
        }

        /// <summary>
        /// Modbus RTU Read - Error Response Data
        /// </summary>
        /// <param name="errorCheck">에러값(0x01~0x04)</param>
        /// <param name="slaveID">Slave ID</param>
        /// <returns></returns>
        public byte[] MakeRTUErrorResponseData(byte errorCheck, int slaveID)
        {
            byte[] sendModbusDatas;
            byte[] crc;

            sendModbusDatas = new byte[5];

            // 0 : Slave ID
            sendModbusDatas[0] = Convert.ToByte(slaveID);
            // 1 : Function Code : 0x04 + 0x80 = 0x84 : 고정값
            sendModbusDatas[1] = 0x84;
            // 2 : Error Code
            sendModbusDatas[2] = errorCheck;
            
            crc = this.MakeRTUCRC(sendModbusDatas, sendModbusDatas.Length - 2);
            for (int i = 0; i < 2; i++)
                sendModbusDatas[sendModbusDatas.Length - 2 + i] = crc[i];

            return sendModbusDatas;
        }

        /// <summary>
        /// Modbus RTU Read - Normal Response Data
        /// </summary>
        /// <param name="madeData">전송할 byte array</param>
        /// <param name="slaveID">Slave ID</param>
        /// <returns></returns>
        public byte[] MakeRTUResponseData(byte[] madeData, int slaveID)
        {
            byte[] sendModbusDatas;
            byte[] crc;

            sendModbusDatas = new byte[5 + madeData.Length];

            // 0 : Slave ID
            sendModbusDatas[0] = Convert.ToByte(slaveID);
            // 1 : Function Code
            sendModbusDatas[1] = 0x04;
            // 2 : Data Length
            sendModbusDatas[2] = Convert.ToByte(madeData.Length);

            for (int i = 0; i < madeData.Length; i++)
                sendModbusDatas[3 + i] = madeData[i];

            crc = this.MakeRTUCRC(sendModbusDatas, sendModbusDatas.Length - 2);
            for (int i = 0; i < 2; i++)
                sendModbusDatas[sendModbusDatas.Length - 2 + i] = crc[i];

            return sendModbusDatas;
        }

        /// <summary>
        /// Modbus RTU Write Data(판정 시 Send)
        /// </summary>
        /// <param name="madeData">전송할 byte array</param>
        /// <param name="slaveID">Slave ID</param>
        /// <param name="startAddress">Start Address</param>
        /// <returns></returns>
        public byte[] MakeRTUSendAllData(byte[] madeData, int slaveID, int startAddress)
        {
            byte[] sendModbusDatas;
            byte[] crc;

            sendModbusDatas = new byte[9 + madeData.Length];

            // 0 : Slave ID
            sendModbusDatas[0] = Convert.ToByte(slaveID);
            // 1 : Function Code
            sendModbusDatas[1] = 0x10;

            // 2~3 : Start Address
            sendModbusDatas[2] = 0x00;
            sendModbusDatas[3] = Convert.ToByte(startAddress);

            // 4~5 : Size
            sendModbusDatas[4] = 0x00;
            sendModbusDatas[5] = 0x22; // 34 registers

            // 6 : Data Length
            sendModbusDatas[6] = 0x44; // 68 bytes

            for (int i = 0; i < madeData.Length; i++)
                sendModbusDatas[7 + i] = madeData[i];

            crc = this.MakeRTUCRC(sendModbusDatas, sendModbusDatas.Length - 2);
            for (int i = 0; i < 2; i++)
                sendModbusDatas[sendModbusDatas.Length - 2 + i] = crc[i];

            return sendModbusDatas;
        }



        /// <summary>
        /// Modbus TCP Read - Error Response Data
        /// </summary>
        /// <param name="readByte">전송받은 전체 byte array</param>
        /// <param name="errorCheck">에러값(0x01~0x04)</param>
        /// <returns></returns>
        public byte[] MakeTCPErrorResponseData(byte[] readByte, byte errorCheck)
        {
            byte[] sendModbusDatas;

            sendModbusDatas = new byte[9];

            // 0~3 : 고정값
            sendModbusDatas[0] = readByte[0];
            sendModbusDatas[1] = readByte[1];
            sendModbusDatas[2] = 0x00;
            sendModbusDatas[3] = 0x00;

            // Unit ID~끝까지의 byte 수
            sendModbusDatas[4] = 0x00;
            sendModbusDatas[5] = 0x03;

            // Unit ID : Tcp에서는 0x01 고정값
            sendModbusDatas[6] = 0x01;
            // Function Code : 0x04 + 0x80 = 0x84 : 고정값
            sendModbusDatas[7] = 0x84;

            sendModbusDatas[8] = errorCheck;

            return sendModbusDatas;
        }

        /// <summary>
        /// Modbus TCP Read - Normal Response Data
        /// </summary>
        /// <param name="readByte">전송받은 전체 byte array</param>
        /// <param name="madeData">전송할 Data byte array</param>
        /// <returns></returns>
        public byte[] MakeTCPResponseData(byte[] readByte, byte[] madeData)
        {
            byte[] totalLength;
            byte[] sendModbusDatas;
            byte[] madeDatas;
            ushort dataLength = (ushort)madeData.Length;

            sendModbusDatas = new byte[9 + dataLength];

            // 0~3 : 고정값
            sendModbusDatas[0] = readByte[0];
            sendModbusDatas[1] = readByte[1];
            sendModbusDatas[2] = 0x00;
            sendModbusDatas[3] = 0x00;

            // BitConverter.GetBytes 사용 시, totalLength는 4 bytes, 끝 두 byte만 사용함.
            totalLength = BitConverter.GetBytes(dataLength + 3).Reverse().ToArray();

            // Unit ID~끝까지의 byte 수
            sendModbusDatas[4] = totalLength[2];
            sendModbusDatas[5] = totalLength[3];

            // Unit ID : Tcp에서는 0x01 고정값
            sendModbusDatas[6] = 0x01;
            //Function code : Read Input Register 0x04 고정값
            sendModbusDatas[7] = 0x04;

            // Byte Count(Data의 개수)
            sendModbusDatas[8] = Convert.ToByte(dataLength);

            madeDatas = new byte[dataLength];
            madeDatas = madeData;

            for (int i = 0; i < dataLength; i++)
                sendModbusDatas[9 + i] = madeDatas[i];

            return sendModbusDatas;
        }

        /// <summary>
        /// Modbus TCP Write Data(판정 시 Send)
        /// </summary>
        /// <param name="madeData">전송할 전체 byte array</param>
        /// <param name="startAddress">Start Address</param>
        /// <returns></returns>
        public byte[] MakeTCPSendAllData(byte[] madeData, int startAddress)
        {
            //byte[] readByte;
            byte[] sendModbusDatas;
            byte[] transactionID;

            if (this.ModbusTransactionID > 65535)
                this.ModbusTransactionID = 0;
            else
                this.ModbusTransactionID++;

            // BitConverter.GetBytes 사용 시, totalLength는 4 bytes, 끝 두 byte만 사용함.
            transactionID = BitConverter.GetBytes(this.ModbusTransactionID).Reverse().ToArray();

            sendModbusDatas = new byte[13 + madeData.Length];

            sendModbusDatas[0] = transactionID[2];
            sendModbusDatas[1] = transactionID[3];
            sendModbusDatas[2] = 0x00;
            sendModbusDatas[3] = 0x00;

            // Length(Unit ID~ 길이)
            sendModbusDatas[4] = 0x00;
            sendModbusDatas[5] = 0x4b;
            // Unit ID
            sendModbusDatas[6] = 0x01;
            // Function code
            sendModbusDatas[7] = 0x10;

            // Start Address
            sendModbusDatas[8] = 0x00;
            sendModbusDatas[9] = Convert.ToByte(startAddress);

            //Length(Word 단위)
            sendModbusDatas[10] = 0x00;
            sendModbusDatas[11] = 0x22;

            // Byte Count(Data의 byte 개수)
            sendModbusDatas[12] = 0x44;

            for (int i = 0; i < madeData.Length; i++)
                sendModbusDatas[13 + i] = madeData[i];

            return sendModbusDatas;
        }
        #endregion
    }
}
